## cowdancer 0.68

=== debian/changelog ===
cowdancer (0.68) unstable; urgency=low

  [ Junichi Uekawa ]
  * remove build-dependency and dependency on qemu, and depend on qemu-
    system.

  [ Dmitry Smirnov ]
  * Bug#660823: qemubuilder: Gnu Hurd support (doesn't quite yet work but first step)

 -- Junichi Uekawa <dancer@debian.org>  Sat, 10 Mar 2012 09:40:54 +0900

=== debian/control ===
Source: cowdancer
Section: utils
Priority: optional
Maintainer: Junichi Uekawa <dancer@debian.org>
Build-Depends: debhelper (>> 4.0.0), pbuilder, 
	       qemu-system [i386 amd64 powerpc], 
	       libklibc-dev, klibc-utils, cpio, busybox-static
Standards-Version: 3.7.2
Vcs-Git: git://git.debian.org/git/pbuilder/cowdancer.git
Vcs-Browser: http://git.debian.org/?p=pbuilder/cowdancer.git

Package: cowdancer
Architecture: any
Depends: ${shlibs:Depends}
Homepage: http://www.netfort.gr.jp/~dancer/software/cowdancer.html
Description: Copy-on-write directory tree utility.
 Tries to make copy-on-write semantics upon hard-link copied
 directory trees generated with 'cp -la'
 .
 'cow-shell' command invokes a shell session. Within that session,
 under the directory cow-shell was invoked, 
 cowdancer will create a new file when existing i-nodes are opened for 
 write.
 Useful for quick scratch workspace and experimentation.
 .
 For a useful Debian tool, try cowbuilder.

Package: cowbuilder
Architecture: any
Depends: ${shlibs:Depends}, pbuilder, cowdancer
Replaces: cowdancer (<= 0.49)
Description: pbuilder running on cowdancer
 'cowbuilder' command is a wrapper for pbuilder which allows using 
 pbuilder-like interface over cowdancer environment.
 .
 pbuilder is a tool for building and testing Debian package inside a clean
 chroot, and cowbuilder allows chroot to be recreated using
 hard-linked copies with copy-on-write, which makes creation and
 destruction of chroots fast.

Package: qemubuilder
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends}, qemu-system | kvm, pbuilder (>= 0.174), debootstrap
Homepage: http://wiki.debian.org/qemubuilder
Description: pbuilder using QEMU as backend
 pbuilder implementation for QEMU.
 .
 qemubuilder create -- builds QEMU cow base image.
 . 
 qemubuilder update -- updates QEMU cow base image.
 . 
 qemubuilder build -- builds package inside QEMU cow base image.
 .
 Gives a pbuilder interface for emulated cross-building environments
 using qemu.
 .
 pbuilder is a tool for building and testing Debian package inside a
 clean chroot, and qemubuilder implements similar experience over
 emulated CPUs. This tool allows building package inside emulated
 Debian environment for different CPU architectures supported by qemu.

## cowdancer 0.69

=== debian/changelog ===
cowdancer (0.69) unstable; urgency=low

  [ Mike Gabriel ]
  * Add SMP support to qemubuilder (closes: #661856)

  [ Junichi Uekawa ]
  * add --keyring and --allow-untrusted options to cowbuilder.

 -- Junichi Uekawa <dancer@debian.org>  Fri, 30 Mar 2012 01:19:48 +0900

## cowdancer 0.70

=== Makefile ===
SHELL=/bin/bash
BINARY=libcowdancer.so cow-shell cowbuilder qemubuilder cowdancer-ilistcreate \
	cowdancer-ilistdump
INSTALL_DIR=install -d -o root -g root -m 755
INSTALL_FILE=install -o root -g root -m 644
INSTALL_PROGRAM=install -o root -g root -m 755
DESTDIR=
PREFIX=/usr
LIBDIR=$(PREFIX)/lib
CFLAGS=-O2 -Wall -g -fno-strict-aliasing
CFLAGS_LFS=$(CFLAGS) $(shell getconf LFS_CFLAGS)
PWD=$(shell pwd)

export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )

all: $(BINARY)

install: $(BINARY)
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/bin
	$(INSTALL_DIR) $(DESTDIR)${LIBDIR}/cowdancer
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man1
	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man8
	$(INSTALL_FILE)  cow-shell.1 $(DESTDIR)/usr/share/man/man1/cow-shell.1
	$(INSTALL_FILE)  cowdancer-ilistcreate.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistcreate.1
	$(INSTALL_FILE)  cowdancer-ilistdump.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistdump.1
	$(INSTALL_FILE)  cowbuilder.8 $(DESTDIR)/usr/share/man/man8/cowbuilder.8
	$(INSTALL_FILE)  qemubuilder.8 $(DESTDIR)/usr/share/man/man8/qemubuilder.8
	$(INSTALL_FILE)  libcowdancer.so $(DESTDIR)${LIBDIR}/cowdancer/libcowdancer.so
	$(INSTALL_PROGRAM) cow-shell $(DESTDIR)/usr/bin/cow-shell
	$(INSTALL_PROGRAM) cowbuilder $(DESTDIR)/usr/sbin/cowbuilder
	$(INSTALL_PROGRAM) qemubuilder $(DESTDIR)/usr/sbin/qemubuilder
	$(INSTALL_PROGRAM) cowdancer-ilistcreate $(DESTDIR)/usr/bin/cowdancer-ilistcreate
	$(INSTALL_PROGRAM) cowdancer-ilistdump $(DESTDIR)/usr/bin/cowdancer-ilistdump

	$(INSTALL_DIR) $(DESTDIR)/etc/bash_completion.d
	$(INSTALL_FILE) bash_completion.qemubuilder $(DESTDIR)/etc/bash_completion.d/qemubuilder
	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/etc/bash_completion.d/cowbuilder

libcowdancer.so: cowdancer.lo ilistcreate.lo
	$(CC) $(CFLAGS) -shared -o $@ $^ -ldl

cow-shell: cow-shell.o ilistcreate.o
	$(CC) $(CFLAGS) -o $@ $^

cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
	$(CC) $(CFLAGS) -o $@ $^

cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o
	$(CC) $(CFLAGS) -o $@ $^

qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso
	$(CC) $(CFLAGS) -o $@ $^

%.lo: %.c 
	$(CC) $(CFLAGS) -fPIC $< -o $@ -c

%.lfso: %.c 
	$(CC) $(CFLAGS_LFS) $< -o $@ -c

%.o: %.c parameter.h
	$(CC) $(CFLAGS) $< -o $@ -c -D LIBDIR="\"${LIBDIR}\""

clean: 
	-rm -f *~ *.o *.lo *.lfso $(BINARY)
	-make -C initrd clean

upload-dist-all:
	scp ../cowdancer_$(VERSION).tar.gz aegis.netfort.gr.jp:public_html/software/downloads

fastcheck:
	set -e; set -o pipefail; for A in ./test_*.c; do echo $$A; \
		./tests/run_c.sh $$A 2>&1 | \
		tee tests/log/$${A/*\//}.log; done

slowcheck: cowdancer-ilistdump qemubuilder cow-shell
	# FIXME: The tests are running installed cowdancer, not the just-built
	set -e; set -o pipefail; for A in tests/[0-9][0-9][0-9]_*.sh; \
	do echo $$A; \
	PATH="$(PWD):$(PWD)/tests:/usr/bin/:/bin" \
	COWDANCER_SO=$(PWD)/libcowdancer.so \
	bash $$A  2>&1 | \
	sed -e's,/tmp/[^/]*,/tmp/XXXX,g' \
	    -e "s,^Current time:.*,Current time: TIME," \
	    -e "s,^pbuilder-time-stamp: .*,pbuilder-time-stamp: XXXX," \
	    -e "s,^Fetched .*B in .*s (.*B/s),Fetched XXXB in Xs (XXXXXB/s)," \
	| tee tests/log/$${A/*\//}.log; done

check: fastcheck slowcheck

check-syntax:
	$(CC) -c $(CFLAGS) $(CHK_SOURCES)  -o/dev/null -D LIBDIR="\"${LIBDIR}\""

.PHONY: clean check upload-dist-all check-syntax fastcheck slowcheck

=== debian/changelog ===
cowdancer (0.70) unstable; urgency=low

  [ Junichi Uekawa ]
  * update to policy 3.9.2
  - delimit build-depends with a newline.
  - add parallel= support for DEB_BUILD_OPTIONS
  - remove -D_REENTRANT from build scripts, they are linuxthreads requirement, and probably obsolete by now.
  - rather than /run use some other script name /runscript for 'execute'
  - add 'nocheck' DEB_BUILD_OPTIONS support
  - removed unneeded files.

  [ Julian Taylor ]
  * expose --twice to cowbuilder too. (closes: #563089)

 -- Junichi Uekawa <dancer@debian.org>  Wed, 30 May 2012 19:02:00 +0900

## cowdancer 0.71

=== debian/changelog ===
cowdancer (0.71) unstable; urgency=low

  * copyright file in copyright-format-1.0 as specified in policy version 3.9.3.1

 -- Junichi Uekawa <dancer@debian.org>  Fri, 24 Aug 2012 04:51:56 +0900

## cowdancer 0.71ubuntu1

=== debian/changelog ===
cowdancer (0.71ubuntu1) raring; urgency=low

  * A directory bind-mounted into pc->buildplace, will be cleaned out by
    rmrf() To avoid this disaster, we skip buildplace clean-up if a directory
    is bind-mounted under the chroot (LP: #1156540)

 -- Jean-Baptiste Lallement <jean-baptiste.lallement@canonical.com>  Tue, 19 Mar 2013 09:35:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,16 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Junichi Uekawa <dancer@debian.org>
-Build-Depends: debhelper (>> 4.0.0), pbuilder, 
-	       qemu-system [i386 amd64 powerpc], 
-	       libklibc-dev, klibc-utils, cpio, busybox-static
-Standards-Version: 3.7.2
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
+Build-Depends: cpio,
+	       busybox-static,
+	       debhelper (>> 4.0.0),
+	       klibc-utils,
+	       libklibc-dev,
+	       pbuilder,
+	       qemu-system [i386 amd64 powerpc]
+Standards-Version: 3.9.2
 Vcs-Git: git://git.debian.org/git/pbuilder/cowdancer.git
 Vcs-Browser: http://git.debian.org/?p=pbuilder/cowdancer.git
 
@@ -18,8 +23,8 @@
  directory trees generated with 'cp -la'
  .
  'cow-shell' command invokes a shell session. Within that session,
- under the directory cow-shell was invoked, 
- cowdancer will create a new file when existing i-nodes are opened for 
+ under the directory cow-shell was invoked,
+ cowdancer will create a new file when existing i-nodes are opened for
  write.
  Useful for quick scratch workspace and experimentation.
  .
@@ -30,7 +35,7 @@
 Depends: ${shlibs:Depends}, pbuilder, cowdancer
 Replaces: cowdancer (<= 0.49)
 Description: pbuilder running on cowdancer
- 'cowbuilder' command is a wrapper for pbuilder which allows using 
+ 'cowbuilder' command is a wrapper for pbuilder which allows using
  pbuilder-like interface over cowdancer environment.
  .
  pbuilder is a tool for building and testing Debian package inside a clean
@@ -46,9 +51,9 @@
  pbuilder implementation for QEMU.
  .
  qemubuilder create -- builds QEMU cow base image.
- . 
+ .
  qemubuilder update -- updates QEMU cow base image.
- . 
+ .
  qemubuilder build -- builds package inside QEMU cow base image.
  .
  Gives a pbuilder interface for emulated cross-building environments

## cowdancer 0.72

=== debian/changelog ===
cowdancer (0.72) unstable; urgency=low

  [ Jean-Baptiste Lallement ]
  * cowbuilder deletes content of bind-mounted directories (closes: #703406)
  - A directory bind-mounted into pc->buildplace, will be cleaned out by
    rmrf() To avoid this disaster, we skip buildplace clean-up if a directory
    is bind-mounted under the chroot (LP: #1156540)

  [ Junichi Uekawa ]
  * Some refactoring, and removing memory leaks.
  * Mark some functions to be static in cowdancer so that they are not exported.

 -- Junichi Uekawa <dancer@debian.org>  Sat, 30 Mar 2013 11:05:19 +0900

## cowdancer 0.73~bpo7+1

=== debian/changelog ===
cowdancer (0.73~bpo7+1) wheezy-backports; urgency=low

  * Upload to wheezy-backports.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 29 Nov 2013 09:59:36 +0100

cowdancer (0.73) unstable; urgency=low

  * debbuildopts quoting is wrong from ~/.pbuilderrc (closes: #704247)
  * do not fail test when '/' is not mounted inside chroot. 
    (closes: #713511)

 -- Junichi Uekawa <dancer@debian.org>  Wed, 24 Jul 2013 06:41:33 +0900

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Junichi Uekawa <dancer@debian.org>
+Uploaders:
+ Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cpio,
 	       busybox-static,
 	       debhelper (>> 4.0.0),

## cowdancer 0.73

=== Makefile ===
--- 
+++ 
@@ -45,7 +45,7 @@
 cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
 	$(CC) $(CFLAGS) -o $@ $^
 
-cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o
+cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o cowbuilder_util.o
 	$(CC) $(CFLAGS) -o $@ $^
 
 qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,6 @@
 Section: utils
 Priority: optional
 Maintainer: Junichi Uekawa <dancer@debian.org>
-Uploaders:
- Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cpio,
 	       busybox-static,
 	       debhelper (>> 4.0.0),

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CFLAGS = -Wall -g -fno-strict-aliasing 
INSTALL = install
export INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
export INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
export INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
export INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif


configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Code to run the package test suite.
	$(MAKE) check
endif
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	-$(MAKE) clean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	$(MAKE) install DESTDIR=$(CURDIR)/debian/cowdancer
	dh_movefiles -pqemubuilder --sourcedir=debian/cowdancer
	dh_movefiles -pcowbuilder --sourcedir=debian/cowdancer

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -s 
	dh_testroot -s 
	dh_installdocs -s NEWS
	dh_installexamples -s 
	dh_installmenu -s 
	dh_installman -s 
	dh_installchangelogs -s ChangeLog
	dh_link -s 
	dh_strip -s 
	dh_shlibdeps -s 
	dh_compress -s 
	dh_fixperms -s 
	dh_installdeb -s 
	dh_gencontrol -s 
	dh_md5sums -s 
	dh_builddeb -s 

# (shell-command "cd ../ ; debian/rules debian/qemubuilder.README.Debian")
debian/qemubuilder.README.Debian:
	w3m -dump 'http://wiki.debian.org/qemubuilder?action=raw' > $@.tmp
	mv $@.tmp $@

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure debian/qemubuilder.README.Debian

=== debian/watch ===
version=2
http://www.netfort.gr.jp/~dancer/software/downloads cowdancer-([\d+\.]+).tar.gz

## cowdancer 0.74+devuan1

=== debian/changelog ===
cowdancer (0.74+devuan1) unstable; urgency=medium

  * Fix segfault on missing parameters to qemubuilder
  * Avoid infinite loop when forked qemu child crash in qemubuilder
  * add support for armhf architecture to qemubuilder

 -- Franco (nextime) Lanza <nextime@devuan.org>  Thu, 02 Apr 2015 21:59:57 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: cowdancer
 Section: utils
 Priority: optional
-Maintainer: Junichi Uekawa <dancer@debian.org>
+Maintainer: Franco (nextime) Lanza <nextime@devuan.org>
 Build-Depends: cpio,
 	       busybox-static,
 	       debhelper (>> 4.0.0),

## cowdancer 0.75

=== Makefile ===
--- 
+++ 
@@ -32,9 +32,9 @@
 	$(INSTALL_PROGRAM) cowdancer-ilistcreate $(DESTDIR)/usr/bin/cowdancer-ilistcreate
 	$(INSTALL_PROGRAM) cowdancer-ilistdump $(DESTDIR)/usr/bin/cowdancer-ilistdump
 
-	$(INSTALL_DIR) $(DESTDIR)/etc/bash_completion.d
-	$(INSTALL_FILE) bash_completion.qemubuilder $(DESTDIR)/etc/bash_completion.d/qemubuilder
-	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/etc/bash_completion.d/cowbuilder
+	$(INSTALL_DIR) $(DESTDIR)/usr/share/bash-completion/completions
+	$(INSTALL_FILE) bash_completion.qemubuilder $(DESTDIR)/usr/share/bash-completion/completions/qemubuilder
+	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/usr/share/bash-completion/completions/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
 	$(CC) $(CFLAGS) -shared -o $@ $^ -ldl

=== debian/changelog ===
cowdancer (0.75) unstable; urgency=medium

  * Updated references to cdn.debian.net to use httpredir.debian.org (Closes:
    #774469)
  * Add armhf support to qemubuilder (Closes: #780332)
  * Move bash completions to standard location
  * d/control:
   - Changed architecture for qemubuilder to linux-any due to missing
     dependencies on kfreebsd and hurd
   - Added ${misc:Depends} to binary dependencies
  * d/copyright:
   - Updating FSF address in GPL references
   - Reference common licenses
  * Add source format "3.0 (native)"

 -- Iain R. Learmonth <irl@debian.org>  Tue, 03 Nov 2015 11:53:25 +0000

cowdancer (0.74) unstable; urgency=medium

  [ Francois Poirotte ]
  * Send benign messages to stdout not stderr. (Closes: #734162)

  [ Iain R. Learmonth ]
  * Removed debian/watch; this is a native package.
  * debian/control:
   - Switch Vcs-Browser and Vcs-Git to canonical URLs.
   - Change maintainer to Debian pbuilder maintenance team.
   - Added self as an Uploader.
   - Reformatted with cme.
  * debian/copyright:
   - DEP-5 compliance fixes.
  * Fixed handling of .dsc files in qemubuilder. (Closes: #779255)
   - Thanks to Stefan Kisdaroczi!

 -- Iain R. Learmonth <irl@debian.org>  Sun, 11 Oct 2015 21:32:40 +0100

=== debian/control ===
Source: cowdancer
Maintainer: Debian pbuilder maintenance team <pbuilder-maint@lists.alioth.debian.org>
Uploaders: Iain R. Learmonth <irl@debian.org>
Section: utils
Priority: optional
Build-Depends: cpio,
               busybox-static,
               debhelper (>> 4.0.0),
               klibc-utils,
               libklibc-dev,
               pbuilder,
               qemu-system [i386 amd64 powerpc]
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pbuilder/cowdancer.git
Vcs-Git: git://anonscm.debian.org/pbuilder/cowdancer.git

Package: cowdancer
Architecture: linux-any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Copy-on-write directory tree utility.
 Tries to make copy-on-write semantics upon hard-link copied
 directory trees generated with 'cp -la'
 .
 'cow-shell' command invokes a shell session. Within that session,
 under the directory cow-shell was invoked,
 cowdancer will create a new file when existing i-nodes are opened for
 write.
 Useful for quick scratch workspace and experimentation.
 .
 For a useful Debian tool, try cowbuilder.
Homepage: http://www.netfort.gr.jp/~dancer/software/cowdancer.html

Package: cowbuilder
Architecture: linux-any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         pbuilder,
         cowdancer
Replaces: cowdancer (<= 0.49)
Description: pbuilder running on cowdancer
 'cowbuilder' command is a wrapper for pbuilder which allows using
 pbuilder-like interface over cowdancer environment.
 .
 pbuilder is a tool for building and testing Debian package inside a clean
 chroot, and cowbuilder allows chroot to be recreated using
 hard-linked copies with copy-on-write, which makes creation and
 destruction of chroots fast.

Package: qemubuilder
Architecture: i386 amd64 powerpc
Depends: ${shlibs:Depends},
         ${misc:Depends},
         qemu-system | kvm,
         pbuilder,
         debootstrap
Description: pbuilder using QEMU as backend
 pbuilder implementation for QEMU.
 .
 qemubuilder create -- builds QEMU cow base image.
 .
 qemubuilder update -- updates QEMU cow base image.
 .
 qemubuilder build -- builds package inside QEMU cow base image.
 .
 Gives a pbuilder interface for emulated cross-building environments
 using qemu.
 .
 pbuilder is a tool for building and testing Debian package inside a
 clean chroot, and qemubuilder implements similar experience over
 emulated CPUs. This tool allows building package inside emulated
 Debian environment for different CPU architectures supported by qemu.
Homepage: http://wiki.debian.org/qemubuilder

## cowdancer 0.76

=== debian/changelog ===
cowdancer (0.76) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * debian/rules:
   - use the dh sequencer and compat 9
   - use CFLAGS from the env, always. dpkg-buildpackage takes care of that in
     debian, just be sure -fno-strict-aliasing is there
   - use LDFLAGS where we actually link stuff
   - use dh_install instead of dh_movefiles
   - enable hardening
  * debian/dirs (removed):
   - let the makefile create the directory, remove debian/dirs
  * qemubuilder.8:
   - remove .qy macro that's not understood by man now
  * cowdancer-ilistcreate.1:
   - remove escaping of round brackets
  * bash_completion.qemubuilder:
   - remove the shebang, bash completion don't want/need the shebang
  * run wrap-and-sort
  * debian/control:
   - remove final dot from cowdancer short description, fix
     description-synopsis-might-not-be-phrased-properly
  * debian/cowbuilder.maintscript:
   - add to remove obsolete /etc/bash_completion/cowbuilder (Closes: #804634)
  * debian/qemubuilder.maintscript:
   - add to remove obsolete /etc/bash_completion/qemubuilder (Closes: #804635)

  [ Iain R. Learmonth ]
  * Ensure qemubuilder mounts rootfs as rw during creation (Closes: #698451)

 -- Iain R. Learmonth <irl@debian.org>  Sun, 13 Dec 2015 11:25:11 +0000

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Uploaders: Iain R. Learmonth <irl@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: cpio,
-               busybox-static,
-               debhelper (>> 4.0.0),
+Build-Depends: busybox-static,
+               cpio,
+               debhelper (>> 9),
                klibc-utils,
                libklibc-dev,
                pbuilder,
@@ -16,9 +16,9 @@
 
 Package: cowdancer
 Architecture: linux-any
-Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Description: Copy-on-write directory tree utility.
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
+Description: Copy-on-write directory tree utility
  Tries to make copy-on-write semantics upon hard-link copied
  directory trees generated with 'cp -la'
  .
@@ -33,10 +33,10 @@
 
 Package: cowbuilder
 Architecture: linux-any
-Depends: ${shlibs:Depends},
+Depends: cowdancer,
+         pbuilder,
          ${misc:Depends},
-         pbuilder,
-         cowdancer
+         ${shlibs:Depends}
 Replaces: cowdancer (<= 0.49)
 Description: pbuilder running on cowdancer
  'cowbuilder' command is a wrapper for pbuilder which allows using
@@ -48,12 +48,12 @@
  destruction of chroots fast.
 
 Package: qemubuilder
-Architecture: i386 amd64 powerpc
-Depends: ${shlibs:Depends},
+Architecture: amd64 i386 powerpc
+Depends: debootstrap,
+         pbuilder,
+         qemu-system | kvm,
          ${misc:Depends},
-         qemu-system | kvm,
-         pbuilder,
-         debootstrap
+         ${shlibs:Depends}
 Description: pbuilder using QEMU as backend
  pbuilder implementation for QEMU.
  .

## cowdancer 0.77

=== debian/changelog ===
cowdancer (0.77) unstable; urgency=medium

  * bash_completion.cowbuilder:
   - Added --configfile (Closes: #744974)

 -- Iain R. Learmonth <irl@debian.org>  Fri, 25 Dec 2015 11:09:25 +0000

## cowdancer 0.78

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 DESTDIR=
 PREFIX=/usr
 LIBDIR=$(PREFIX)/lib
-CFLAGS=-O2 -Wall -g -fno-strict-aliasing
+CFLAGS := $(CFLAGS) -fno-strict-aliasing
 CFLAGS_LFS=$(CFLAGS) $(shell getconf LFS_CFLAGS)
 PWD=$(shell pwd)
 
@@ -17,6 +17,7 @@
 
 install: $(BINARY)
 	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/bin
+	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/sbin
 	$(INSTALL_DIR) $(DESTDIR)${LIBDIR}/cowdancer
 	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man1
 	$(INSTALL_DIR) $(DESTDIR)${PREFIX}/share/man/man8
@@ -37,24 +38,24 @@
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/usr/share/bash-completion/completions/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
-	$(CC) $(CFLAGS) -shared -o $@ $^ -ldl
+	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl
 
 cow-shell: cow-shell.o ilistcreate.o
-	$(CC) $(CFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
 cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
-	$(CC) $(CFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
 cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o cowbuilder_util.o
-	$(CC) $(CFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
 qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso
-	$(CC) $(CFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
-%.lo: %.c 
+%.lo: %.c
 	$(CC) $(CFLAGS) -fPIC $< -o $@ -c
 
-%.lfso: %.c 
+%.lfso: %.c
 	$(CC) $(CFLAGS_LFS) $< -o $@ -c
 
 %.o: %.c parameter.h

=== debian/changelog ===
cowdancer (0.78) unstable; urgency=medium

  * debian/control:
   - Change qemubuilder architecture to any

 -- Iain R. Learmonth <irl@debian.org>  Fri, 25 Dec 2015 14:30:43 +0000

=== debian/control ===
--- 
+++ 
@@ -48,7 +48,7 @@
  destruction of chroots fast.
 
 Package: qemubuilder
-Architecture: amd64 i386 powerpc
+Architecture: any
 Depends: debootstrap,
          pbuilder,
          qemu-system | kvm,

## cowdancer 0.79

=== debian/changelog ===
cowdancer (0.79) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * debian/control:
    - Remove qemu-system Build-Dep, it's clearly useless.
    - Restrict qemubuilder to linux-any architectures.
    - Bump Standards-Version to 3.9.7, no changes needed.
    - Use HTTPS in Vcs-Git

  [ James Clarke ]
  * debian/control:
    - Add myself to Uploaders. (Closes: #802151)
    - Drop unused busybox-static from Build-Depends.
    - Build everything except qemubuilder on Architecture: any
  * Fix open/open64 giving SIGILL on kFreeBSD. (Closes: #647345)
  * tests/016_memleakcheck.c:
    - Check result of opening /proc/self/maps for NULL.
    - Use /proc/<pid>/maps over /proc/self/maps.
      This fixes the test failing on the Hurd, as /proc/self is currently
      always /proc/1.
  * Makefile:
    - Define DEB_BUILD_ARCH_OS.
    - Don't build qemubuilder when DEB_BUILD_ARCH_OS != "linux".
    - Create tests/log directory if missing
  * qemubuilder.c:
    - Don't hang if child crashes (Closes: #752582)
    - Exit gracefully when missing KERNEL_IMAGE (LP: #1027268)
    - Make kernel halt on panic, rather than hanging
    - Support EXTRAPACKAGES/--extrapackages
    - Specify disk image format for qemu (Closes: #812581)
    - Avoid needless string copy
  * cowbuilder:
    - Don't override --extrapackages (Closes: #606542)
  * cowbuilder.c:
    - Always check for mounts before deleting directories (Closes: #758490)
    - Don't duplicate --debbuildopts (Closes: #754048)
  * tests/log:
    - Remove unnecessary directory
  * parameter.c:
    - Avoid // in buildplace (Closes: #573126)

 -- James Clarke <jrtc27@jrtc27.com>  Mon, 04 Apr 2016 19:21:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,20 @@
 Source: cowdancer
 Maintainer: Debian pbuilder maintenance team <pbuilder-maint@lists.alioth.debian.org>
-Uploaders: Iain R. Learmonth <irl@debian.org>
+Uploaders: Iain R. Learmonth <irl@debian.org>,
+           James Clarke <jrtc27@jrtc27.com>
 Section: utils
 Priority: optional
-Build-Depends: busybox-static,
-               cpio,
+Build-Depends: cpio,
                debhelper (>> 9),
-               klibc-utils,
-               libklibc-dev,
+               klibc-utils [linux-any],
+               libklibc-dev [linux-any],
                pbuilder,
-               qemu-system [i386 amd64 powerpc]
-Standards-Version: 3.9.6
-Vcs-Browser: https://anonscm.debian.org/cgit/pbuilder/cowdancer.git
-Vcs-Git: git://anonscm.debian.org/pbuilder/cowdancer.git
+Standards-Version: 3.9.7
+Vcs-Browser: https://anonscm.debian.org/git/pbuilder/cowdancer.git
+Vcs-Git: https://anonscm.debian.org/git/pbuilder/cowdancer.git
 
 Package: cowdancer
-Architecture: linux-any
+Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Description: Copy-on-write directory tree utility
@@ -32,7 +31,7 @@
 Homepage: http://www.netfort.gr.jp/~dancer/software/cowdancer.html
 
 Package: cowbuilder
-Architecture: linux-any
+Architecture: any
 Depends: cowdancer,
          pbuilder,
          ${misc:Depends},
@@ -48,7 +47,7 @@
  destruction of chroots fast.
 
 Package: qemubuilder
-Architecture: any
+Architecture: linux-any
 Depends: debootstrap,
          pbuilder,
          qemu-system | kvm,

## cowdancer 0.80~bpo8+1

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
 SHELL=/bin/bash
-BINARY=libcowdancer.so cow-shell cowbuilder qemubuilder cowdancer-ilistcreate \
+DEB_BUILD_ARCH_OS ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
+BINARY := libcowdancer.so cow-shell cowbuilder cowdancer-ilistcreate \
 	cowdancer-ilistdump
+ifeq ($(DEB_BUILD_ARCH_OS),linux)
+	BINARY := $(BINARY) qemubuilder
+endif
 INSTALL_DIR=install -d -o root -g root -m 755
 INSTALL_FILE=install -o root -g root -m 644
 INSTALL_PROGRAM=install -o root -g root -m 755
@@ -25,16 +29,22 @@
 	$(INSTALL_FILE)  cowdancer-ilistcreate.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistcreate.1
 	$(INSTALL_FILE)  cowdancer-ilistdump.1 $(DESTDIR)/usr/share/man/man1/cowdancer-ilistdump.1
 	$(INSTALL_FILE)  cowbuilder.8 $(DESTDIR)/usr/share/man/man8/cowbuilder.8
+ifeq ($(DEB_BUILD_ARCH_OS),linux)
 	$(INSTALL_FILE)  qemubuilder.8 $(DESTDIR)/usr/share/man/man8/qemubuilder.8
+endif
 	$(INSTALL_FILE)  libcowdancer.so $(DESTDIR)${LIBDIR}/cowdancer/libcowdancer.so
 	$(INSTALL_PROGRAM) cow-shell $(DESTDIR)/usr/bin/cow-shell
 	$(INSTALL_PROGRAM) cowbuilder $(DESTDIR)/usr/sbin/cowbuilder
+ifeq ($(DEB_BUILD_ARCH_OS),linux)
 	$(INSTALL_PROGRAM) qemubuilder $(DESTDIR)/usr/sbin/qemubuilder
+endif
 	$(INSTALL_PROGRAM) cowdancer-ilistcreate $(DESTDIR)/usr/bin/cowdancer-ilistcreate
 	$(INSTALL_PROGRAM) cowdancer-ilistdump $(DESTDIR)/usr/bin/cowdancer-ilistdump
 
 	$(INSTALL_DIR) $(DESTDIR)/usr/share/bash-completion/completions
+ifeq ($(DEB_BUILD_ARCH_OS),linux)
 	$(INSTALL_FILE) bash_completion.qemubuilder $(DESTDIR)/usr/share/bash-completion/completions/qemubuilder
+endif
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/usr/share/bash-completion/completions/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo
@@ -68,23 +78,37 @@
 upload-dist-all:
 	scp ../cowdancer_$(VERSION).tar.gz aegis.netfort.gr.jp:public_html/software/downloads
 
-fastcheck:
+tests/log:
+	mkdir -p $@
+
+fastcheck: tests/log
 	set -e; set -o pipefail; for A in ./test_*.c; do echo $$A; \
-		./tests/run_c.sh $$A 2>&1 | \
+		if [ "$(DEB_BUILD_ARCH_OS)" != "linux" ] && [ "$${A:0:11}" == "./test_qemu" ]; then \
+			echo "Skipping (qemubuilder is only supported on linux-any)"; \
+		else \
+			./tests/run_c.sh $$A 2>&1; \
+		fi | \
 		tee tests/log/$${A/*\//}.log; done
 
-slowcheck: cowdancer-ilistdump qemubuilder cow-shell
+ifeq ($(DEB_BUILD_ARCH_OS),linux)
+slowcheck: tests/log cowdancer-ilistdump qemubuilder cow-shell
+else
+slowcheck: tests/log cowdancer-ilistdump cow-shell
+endif
 	# FIXME: The tests are running installed cowdancer, not the just-built
 	set -e; set -o pipefail; for A in tests/[0-9][0-9][0-9]_*.sh; \
 	do echo $$A; \
-	PATH="$(PWD):$(PWD)/tests:/usr/bin/:/bin" \
-	COWDANCER_SO=$(PWD)/libcowdancer.so \
-	bash $$A  2>&1 | \
-	sed -e's,/tmp/[^/]*,/tmp/XXXX,g' \
-	    -e "s,^Current time:.*,Current time: TIME," \
-	    -e "s,^pbuilder-time-stamp: .*,pbuilder-time-stamp: XXXX," \
-	    -e "s,^Fetched .*B in .*s (.*B/s),Fetched XXXB in Xs (XXXXXB/s)," \
-	| tee tests/log/$${A/*\//}.log; done
+	if [ "$(DEB_BUILD_ARCH_OS)" != "linux" ] && [ "$${A:0:40}" == "tests/101_test_qemubuilder_dumpconfig.sh" ]; then \
+		echo "Skipping (qemubuilder is only supported on linux-any)"; \
+	else \
+		PATH="$(PWD):$(PWD)/tests:/usr/bin/:/bin" \
+		COWDANCER_SO=$(PWD)/libcowdancer.so \
+		bash $$A  2>&1 | \
+		sed -e's,/tmp/[^/]*,/tmp/XXXX,g' \
+			-e "s,^Current time:.*,Current time: TIME," \
+			-e "s,^pbuilder-time-stamp: .*,pbuilder-time-stamp: XXXX," \
+			-e "s,^Fetched .*B in .*s (.*B/s),Fetched XXXB in Xs (XXXXXB/s),"; \
+	fi | tee tests/log/$${A/*\//}.log; done
 
 check: fastcheck slowcheck

=== debian/changelog ===
cowdancer (0.80~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * qemubuilder.c:
    - Change for-loops to be C89-compliant

 -- James Clarke <jrtc27@jrtc27.com>  Thu, 30 Jun 2016 22:49:23 +0100

cowdancer (0.80) unstable; urgency=medium

  [ James Clarke ]
  * qemuarch.c:
    - Support x32
  * test_qemuarch.c:
    - Support x32
  * cowbuilder.c:
    - Preserve directory when --debug is given (Closes: #650592)
  * Add support for pbuilder's --binary-indep
    - Only use --force-yes if --allow-untrusted is given
      (Closes: #819093)
    - Add support for hooks.
      Thanks to Reiner Herrmann for the initial concept patch.
      (Closes: #819803)
    - Copy files back as the correct user/group
    - Increase MEMORY_MEGS default to 256
  * qemubuilder.c:
    - Mount /run/lock and /dev/shm as tmpfs
  * qemubuilder.c:
    - Update first-stage script in --update
  * qemubuilder.c:
    - Run hooks from mountpoint and use input/ for copying
    - Build inside /build
    - Detect out of date pbuilder-run init script
    - Update script by mounting root
    - Fixed end-of-work exit code
    - Fixed non-executable hook warning
    - Compatibility symlink from /tmp/buildd to /build
    - Avoid first-stage warnings
    - Delete /pbuilder-run before version check
    - Use tmpfs for /tmp
    - Run commands inside getty
    - Use qemu monitor, with sane tty settings
  * file.c:
    - Preserve permissions on copy

  [ Mattia Rizzolo ]
  * debian/control:
    - Bump Standards-Version to 3.9.8, no changes needed.
  * debian/control:
    - add myself to Uploaders.

  [ Peter Pentchev ]
  * qemubuilder.c:
    - Fixed inverted error check for asprintf breaking --update
      (Closes: #822849)

 -- James Clarke <jrtc27@jrtc27.com>  Mon, 16 May 2016 10:51:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cowdancer
 Maintainer: Debian pbuilder maintenance team <pbuilder-maint@lists.alioth.debian.org>
 Uploaders: Iain R. Learmonth <irl@debian.org>,
-           James Clarke <jrtc27@jrtc27.com>
+           James Clarke <jrtc27@jrtc27.com>,
+           Mattia Rizzolo <mattia@debian.org>,
 Section: utils
 Priority: optional
 Build-Depends: cpio,
@@ -9,7 +10,7 @@
                klibc-utils [linux-any],
                libklibc-dev [linux-any],
                pbuilder,
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/git/pbuilder/cowdancer.git
 Vcs-Git: https://anonscm.debian.org/git/pbuilder/cowdancer.git

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel

override_dh_install:
	dh_install --fail-missing

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

# (shell-command "cd ../ ; debian/rules debian/qemubuilder.README.Debian")
debian/qemubuilder.README.Debian:
	w3m -dump 'http://wiki.debian.org/qemubuilder?action=raw' > $@.tmp
	mv $@.tmp $@

## cowdancer 0.80ubuntu1

=== debian/changelog ===
cowdancer (0.80ubuntu1) yakkety; urgency=medium

  * Build with -02 in ppc64el, try to fix FTBFS

 -- Mattia Rizzolo <mapreri@ubuntu.com>  Wed, 01 Jun 2016 17:02:56 +0000

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,13 @@
 #!/usr/bin/make -f
 export DH_VERBOSE=1
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
+
+ifeq ($(DEB_HOST_ARCH),ppc64el)
+export DEB_CFLAGS_MAINT_STRIP = -O3
+export DEB_CFLAGS_MAINT_APPEND = -O2
+endif
 
 %:
 	dh $@ --parallel

## cowdancer 0.81

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,7 @@
 CFLAGS := $(CFLAGS) -fno-strict-aliasing
 CFLAGS_LFS=$(CFLAGS) $(shell getconf LFS_CFLAGS)
 PWD=$(shell pwd)
+LDFLAGS += -lncurses
 
 export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )
 
@@ -47,19 +48,22 @@
 endif
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/usr/share/bash-completion/completions/cowbuilder
 
-libcowdancer.so: cowdancer.lo ilistcreate.lo
+libcowdancer.so: cowdancer.lo ilistcreate.lo log.lo
 	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl
 
-cow-shell: cow-shell.o ilistcreate.o
+cow-shell: cow-shell.o ilistcreate.o log.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
-cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o
+cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o log.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
-cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o cowbuilder_util.o
+cowdancer-ilistdump: cowdancer-ilistdump.o log.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
-qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso
+cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o cowbuilder_util.o log.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+
+qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso log.lfso
 	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
 
 %.lo: %.c
@@ -71,7 +75,7 @@
 %.o: %.c parameter.h
 	$(CC) $(CFLAGS) $< -o $@ -c -D LIBDIR="\"${LIBDIR}\""
 
-clean: 
+clean:
 	-rm -f *~ *.o *.lo *.lfso $(BINARY)
 	-make -C initrd clean

=== debian/changelog ===
cowdancer (0.81) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * Build with -O2 on ppc64el to fix FTBFS in Ubuntu (that is using -O3)

  [ Iain R. Learmonth ]
  * Removing myself from uploaders

  [ James Clarke ]
  * Unify logging and add colors
    - There is now more consistency with the logging format. Every
      cowbuilder/qemubuilder message is now prefixed with the log level.
    - The new USECOLORS pbuilder configuration variable (yes, no or auto) is
      read, and if yes (or auto, and the terminal supports colors), the same
      colors are used as pbuilder.
    - The LOGLEVEL pbuilder configuration variable now also controls
      cowbuilder/qemubuilder's verbosity.
  * Add quotes around arguments with spaces when printing forked commands

 -- James Clarke <jrtc27@jrtc27.com>  Tue, 13 Sep 2016 12:00:38 +0100

## cowdancer 0.81ubuntu1

=== Makefile ===
--- 
+++ 
@@ -15,6 +15,10 @@
 CFLAGS_LFS=$(CFLAGS) $(shell getconf LFS_CFLAGS)
 PWD=$(shell pwd)
 LDFLAGS += -lncurses
+CFLAGS_LIB := $(filter-out -pie,$(CFLAGS))
+CFLAGS_LIB := $(filter-out -fPIE,$(CFLAGS_LIB))
+LDFLAGS_LIB := $(filter-out -pie,$(LDFLAGS))
+LDFLAGS_LIB := $(filter-out -fPIE,$(LDFLAGS_LIB))
 
 export VERSION=$(shell sed -n '1s/.*(\(.*\)).*$$/\1/p' < debian/changelog )
 
@@ -49,22 +53,22 @@
 	$(INSTALL_FILE) bash_completion.cowbuilder $(DESTDIR)/usr/share/bash-completion/completions/cowbuilder
 
 libcowdancer.so: cowdancer.lo ilistcreate.lo log.lo
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl
+	$(CC) $(CFLAGS_LIB) -fpic -fPIC -shared -o $@ $^ -ldl $(LDFLAGS_LIB)
 
 cow-shell: cow-shell.o ilistcreate.o log.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
 
 cowdancer-ilistcreate: cowdancer-ilistcreate.o ilistcreate.o log.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
 
 cowdancer-ilistdump: cowdancer-ilistdump.o log.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
 
 cowbuilder: cowbuilder.o parameter.o forkexec.o ilistcreate.o main.o cowbuilder_util.o log.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
 
 qemubuilder: qemubuilder.lfso parameter.lfso forkexec.lfso qemuipsanitize.lfso qemuarch.lfso file.lfso main.lfso log.lfso
-	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^
+	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
 
 %.lo: %.c
 	$(CC) $(CFLAGS) -fPIC $< -o $@ -c

=== debian/changelog ===
cowdancer (0.81ubuntu1) yakkety; urgency=medium

  * Fix build by moving LDFLAGS to the right position,
    and removing bad pie and fPIE flags in library creation.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 26 Sep 2016 07:03:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: cowdancer
 Maintainer: Debian pbuilder maintenance team <pbuilder-maint@lists.alioth.debian.org>
-Uploaders: Iain R. Learmonth <irl@debian.org>,
-           James Clarke <jrtc27@jrtc27.com>,
+Uploaders: James Clarke <jrtc27@jrtc27.com>,
            Mattia Rizzolo <mattia@debian.org>,
 Section: utils
 Priority: optional
@@ -9,6 +8,7 @@
                debhelper (>> 9),
                klibc-utils [linux-any],
                libklibc-dev [linux-any],
+               libncurses-dev,
                pbuilder,
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/git/pbuilder/cowdancer.git

=== debian/rules ===
--- 
+++ 
@@ -4,9 +4,13 @@
 
 DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
+# Work around FTBFS on ppc64el in Ubuntu, which uses -O3 by default instead
+# of -O2 like Debian. TODO: Investigate and fix root cause.
 ifeq ($(DEB_HOST_ARCH),ppc64el)
+ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
 export DEB_CFLAGS_MAINT_STRIP = -O3
 export DEB_CFLAGS_MAINT_APPEND = -O2
+endif
 endif
 
 %:

## cowdancer 0.82~bpo8+1

=== debian/changelog ===
cowdancer (0.82~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * qemubuilder.c: Change for-loops to be C89-compliant

 -- James Clarke <jrtc27@jrtc27.com>  Mon, 19 Dec 2016 22:31:38 +0000

cowdancer (0.82) unstable; urgency=medium

  [ James Clarke ]
  * Rewrite build system to use autotools instead of home-grown Makefile
  * qemubuilder: Add support for arm64 (Closes: #838753)

  [ Mattia Rizzolo ]
  * Bump debhelper compat level to 10
  * d/rules: drop override_dh_installchangelogs installing ChangeLog: it's
    installed automatically since compat 7

  [ James Clarke ]
  * cowdancer: Use multiarch library path
  * log.c: Silence colors termcap error (Closes: 845395)

 -- James Clarke <jrtc27@jrtc27.com>  Mon, 05 Dec 2016 00:42:45 +0000

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Section: utils
 Priority: optional
 Build-Depends: cpio,
-               debhelper (>> 9),
+               debhelper (>= 10),
+               dh-exec,
                klibc-utils [linux-any],
                libklibc-dev [linux-any],
                libncurses-dev,

## cowdancer 0.82

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,10 @@
 endif
 
 %:
-	dh $@ --parallel
+	dh $@
 
 override_dh_install:
 	dh_install --fail-missing
-
-override_dh_installchangelogs:
-	dh_installchangelogs ChangeLog
 
 # (shell-command "cd ../ ; debian/rules debian/qemubuilder.README.Debian")
 debian/qemubuilder.README.Debian:

## cowdancer 0.83~bpo8+1

=== debian/changelog ===
cowdancer (0.83~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * qemubuilder.c: Change for-loops to be C89-compliant

 -- James Clarke <jrtc27@debian.org>  Wed, 18 Jan 2017 18:54:43 +0000

cowdancer (0.83) unstable; urgency=medium

  * parameter.c: Print a friendlier message when basepath can't be created
    (Closes: #753008)
  * debian/control: Use my @debian.org email address
  * debian/copyright: Add myself (2016-2017)
  * Revert "cowdancer: Use multiarch library path"
  * Symlink multiarch path to non-multiarch path (Closes: #850453)
    - If a user has updated their chroot to 0.82, this will cause a few errors
      again on unpack, but this will be a very short window.

 -- James Clarke <jrtc27@debian.org>  Sat, 07 Jan 2017 11:51:22 +0000

## cowdancer 0.83

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: cowdancer
 Maintainer: Debian pbuilder maintenance team <pbuilder-maint@lists.alioth.debian.org>
-Uploaders: James Clarke <jrtc27@jrtc27.com>,
+Uploaders: James Clarke <jrtc27@debian.org>,
            Mattia Rizzolo <mattia@debian.org>,
 Section: utils
 Priority: optional

=== debian/rules ===
--- 
+++ 
@@ -16,6 +16,12 @@
 %:
 	dh $@
 
+# Multiarch is supported, but to support upgrades, the library needs to stay in
+# the non-multiarch path for one release with a symlink from the multiarch
+# path. See #850453.
+override_dh_auto_configure:
+	dh_auto_configure -- --libdir='$${prefix}/lib' --libexecdir='$${prefix}/lib'
+
 override_dh_install:
 	dh_install --fail-missing

## cowdancer 0.84~bpo8+1

=== debian/changelog ===
cowdancer (0.84~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Makefile.am: Use TESTS_ENVIRONMENT, since jessie's automake uses serial
    test harness

 -- James Clarke <jrtc27@debian.org>  Mon, 30 Jan 2017 16:56:53 +0000

cowdancer (0.84) unstable; urgency=medium

  [ James Clarke ]
  * Use automake for tests
  * Don't run 016_memleakcheck for now
    - Fixes FTBFS on hurd-i386
  * Reformat everything with the help of clang-format
  * Fix miscellaneous issues found by clang-tidy
  * debian/control:
    - Drop unused Build-Depends
    - Update Build-Depends for cross-building
  * cowbuilder: Pass --architecture to pbuilder when building
  * qemubuilder:
    - Check architecture has been specified (Closes: #440944)
    - Allow custom debootstrap and options (Closes: #851226)
    - Change for-loops to be C89-compliant
    - Enable KVM via -machine (kvm binary is deprecated)
  * parameter:
    - Add missing fields to dump_config and reorder
    - Remove duplicate hookdir definition
    - Sync options with pbuilder 0.228
    - Update short options
    - Accept aliases for the operation to perform
  * cowbuilder.8:
    - Update for new command aliases
    - Various cleanups
  * qemubuilder.8:
    - Update for new command aliases
    - Various cleanups

  [ Mattia Rizzolo ]
  * debian/rules: Mark debian/qemubuilder.README.Debian target as .PHONY, so
    it'll always run when called
  * debian/qemubuilder.README.Debian: update from the wiki

 -- James Clarke <jrtc27@debian.org>  Thu, 19 Jan 2017 14:41:27 +0000

## cowdancer 0.85~bpo8+1

=== debian/changelog ===
cowdancer (0.85~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.
  * Makefile.am: Use TESTS_ENVIRONMENT, since jessie's automake uses serial
    test harness

 -- James Clarke <jrtc27@debian.org>  Sun, 12 Feb 2017 19:40:14 +0000

cowdancer (0.85) unstable; urgency=medium

  * cowbuilder.8: Don't document the option-style commands; they're confusing
    and no longer recommended
  * parameter.c: Allow commands to come later; deprecation warnings not given,
    since at least one reverse dependency does not call cowbuilder correctly
    (Closes: #852434)

 -- James Clarke <jrtc27@debian.org>  Tue, 31 Jan 2017 17:16:13 +0000

## cowdancer 0.85

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,10 @@
            Mattia Rizzolo <mattia@debian.org>,
 Section: utils
 Priority: optional
-Build-Depends: cpio,
-               debhelper (>= 10),
+Build-Depends: debhelper (>= 10),
                dh-exec,
-               klibc-utils [linux-any],
-               libklibc-dev [linux-any],
                libncurses-dev,
-               pbuilder,
+               pbuilder <!nocheck>,
 Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/git/pbuilder/cowdancer.git
 Vcs-Git: https://anonscm.debian.org/git/pbuilder/cowdancer.git

## cowdancer 0.86~bpo9+1

=== debian/changelog ===
cowdancer (0.86~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- James Clarke <jrtc27@debian.org>  Thu, 25 Jan 2018 20:47:58 +0000

cowdancer (0.86) unstable; urgency=medium

  * Bump standards version to 4.1.3, no changes needed
  * ilistcreate: Ensure .ilist has the correct permissions (Closes: #872597)
  * cowbuilder: Always pass --mirror and --distribution to pbuilder
  * qemubuilder: Depend on soon-to-be non-Essential e2fsprogs (Closes: #887239)
  * debian/control:
    - Change Vcs-* to point to salsa
    - Set Rules-Requires-Root to no
  * Bump compat to 11, no changes needed

 -- James Clarke <jrtc27@debian.org>  Sat, 20 Jan 2018 12:51:55 +0000
